#include<bits/stdc++.h>
using namespace std;


int poredjenje(string s1,string s2)
{
    int br=0;
    if(s1.length()!=s2.length())
        return 1;
    for(int i=0; i<s1.length(); i++)
    {
        if(s1[i]!=s2[i])
            br++;
    }
    if(br==0)
        return 1;
    else
        return 1;
}
int main ()
{
    int n;
    int o,a,b,ab,x,k=0;
    cin>>n;
    cin>>o>>a>>b>>ab;
    int br_vakcina[n];
    int matrica[n][4];
    char s[n];
    for(int i=0; i<n; i++)
    {
        cin>>s[i];
        cin>>br_vakcina[i];
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=='O')
        {
            if(o<br_vakcina[i])
                k++;
            else
            {

                if(br_vakcina[i]==o)
                {
                    br_vakcina[i]=0;
                }
                else
                    o-=br_vakcina[i];
                matrica[i][0]=br_vakcina[i];
                matrica[i][1]=0;
                matrica[i][2]=0;
                matrica[i][3]=0;
            }

        }
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=='A')
        {
            if(br_vakcina[i]>(a+o))
                k++;

            else
            {
                if(br_vakcina[i]<=a)
                {


                    matrica[i][0]=0;
                    matrica[i][1]=br_vakcina[i];
                    matrica[i][2]=0;
                    matrica[i][3]=0;
                    a-=br_vakcina[i];
                    br_vakcina[i]=0;
                }
                else
                {


                    matrica[i][0]=br_vakcina[i]-a;
                    matrica[i][1]=a;
                    matrica[i][2]=0;
                    matrica[i][3]=0;
                    o=o+(a-br_vakcina[i]);
                    br_vakcina[i]=0;
                    a=0;
                }
            }

        }
    }
    for(int i=0; i<n; i++)
    {
        if(s[i]=='B')
        {
            if(br_vakcina[i]>(b+o))
                k++;

            else
            {
                if(br_vakcina[i]<=b)
                {
                    matrica[i][0]=0;
                    matrica[i][1]=0;
                    matrica[i][2]=br_vakcina[i];
                    matrica[i][3]=0;
                    b-=br_vakcina[i];
                    br_vakcina[i]=0;
                }
                else
                {


                    matrica[i][0]=br_vakcina[i]-b;
                    matrica[i][1]=0;
                    matrica[i][2]=b;
                    matrica[i][3]=0;

                    o=o+(b-br_vakcina[i]);
                    br_vakcina[i]=0;
                    b=0;
                }
            }

        }

    }
    /* for(int i=0; i<n; i++)
     {
         if(poredjenje(s[i],sab)==0)
         {
             if(br_vakcina[i]>(ab+o+a+b))
                 cout<<"nemoguce";
             else
             {
                 if(br_vakcina[i]<ab)
                 {
                     ab-=br_vakcina[i];
                     br_vakcina[i]=0;

                 }
                 else
                 {
                    x=a+b+ab+o-br_vakcina[i];
                   if(o>=x)
                     o-=x;
                     else
                   {
                       if(a>=x)
                         a-=x;
                       else
                       {
                           if(b>=x)
                             b-=x;
                       }
                   }
                 }
             } cout<<"AB";
         }
     }
     if(k!=0)
         cout<<"nemoguce";*/
    if(k==0)
    {
        cout<<"moguce"<<endl;
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<4; j++)
                cout<<matrica[i][j]<<' ';
            cout<<endl;
        }
    }
    else
        cout<<"nemoguce";
    return 0;
}